#include <iostream>
using namespace std;


int main() {

    int Kada_je_kupio;
    int od_kad_jede;

    cin >> Kada_je_kupio >> od_kad_jede;

  
    long long dan_kupovine[300000];
    long long koliko_kutija[300000];

    for (int i = 0; i < Kada_je_kupio;i++) {

        cin >> dan_kupovine[i] >> koliko_kutija[i];


    }


    

    for (int i = 0;i < od_kad_jede; i++) {



        long long koji_Dan;
        cin >> koji_Dan;

        long long brojac = 0;

        for (int j = 0;j < Kada_je_kupio; j++) {
            
            if (dan_kupovine[j] <= koji_Dan) {

                brojac++ ;



            }

            else {

                break;



            }


        }



        cout << brojac << endl;;



    }












    return 0;
}